CON
  ' Set up the processor clock in the standard way for 80MHz on HYBRID
  ' You will want to edit this to reflect your clock setup
  ' Also necessary is editing the pin definitions, and that's done in the driver itself.
_CLKMODE = xtal1 + pll16x
_XINFREQ = 6_000_000 + 0000

VAR

  word    pc
  long    clock
  byte    A, X, Y, SR, FR
  byte    instruction
  word    address
  byte    addressl
  byte    addressh
  byte    ALU


PUB execute (start_address)

    init_registers
    PC := start_address

    repeat 50
      fetch_opcode(PC)
      compute

    

PUB compute

    case instruction
       $a9 : LDA_immediate      'LDA #xx
       $a2 : LDX_immediate      'LDX #xx
       $9d : STA_abs_x          'STA $xxxx, X
       $ca : DEX                'DEX
       $e0 : CPX_immediate      'CPX #xx
       $d0 : BNE_immediate      'BNE #xx
       
       




PRI LDA_immediate
    A := byte[PC]
    PC++

PRI LDX_immediate
    X := byte[PC]
    PC++

PRI STA_abs_x
    addressl := byte[PC]
    PC++
    addressh := byte[PC]
    PC++
    address := addressl + addressh << 8
    byte [address] [X] := A

PRI DEX
    X--

PRI CPX_immediate
    ALU := byte[PC]
    PC++
    if X == ALU
       FR := 1
    else       
       FR := 0

PRI BNE_immediate
    ALU := byte[PC]
    PC++
    if FR == 1
      RETURN
    PC := PC - 8 'yah it's a hack!


PRI fetch_opcode (read_address)
     
      instruction := byte [read_address]
      PC++
      


PRI init_registers

    A := 0
    X := 0
    Y := 0
    SR := 0
    FR := 0
    